function kernelDensityEstimate(data, point, bandwidth, useTriangular){//, normalizedKernel=true) {
    var density = 0;
    var n = data.length;
    var kernel;

    // if(normalizedKernel){
    kernel = useTriangular ? triangularKernel : gaussianKernel;
    // }else{
    //     kernel = useTriangular ? triangularKernel1 : gaussianKernel1;
    // }
    var totalWeight = 0;
    for (var i = 0; i < n; i++) {
        var w = 1.0;
        if (typeof data[i].weight !== 'undefined') {
            w = data[i].weight;
        }
        density += w*kernel((point - data[i].x) / bandwidth);
        totalWeight+=bandwidth*w;
    }

    return density / totalWeight;
}

function gaussianKernel(x) {
    return (1.0 / Math.sqrt(2.0 * Math.PI)) * Math.exp(-0.5 * x * x);
}

function triangularKernel(x) {
    var _x = Math.max(Math.min(x,1.0),-1);
    return (1.0 - Math.abs(_x));
}

module.exports = {gaussianKernel, triangularKernel, kernelDensityEstimate}